Save This Page
Home » struts-2.0.11.2-src » org.apache » struts2 » dispatcher » [javadoc | source]
org.apache.struts2.dispatcher
public class: ServletActionRedirectResult [javadoc | source]
java.lang.Object
   org.apache.struts2.dispatcher.StrutsResultSupport
      org.apache.struts2.dispatcher.ServletRedirectResult
         org.apache.struts2.dispatcher.ServletActionRedirectResult

All Implemented Interfaces:
    com.opensymphony.xwork2.Result, StrutsStatics

This result uses the ActionMapper provided by the ActionMapperFactory to redirect the browser to a URL that invokes the specified action and (optional) namespace. This is better than the ServletRedirectResult because it does not require you to encode the URL patterns processed by the ActionMapper in to your struts.xml configuration files. This means you can change your URL patterns at any point and your application will still work. It is strongly recommended that if you are redirecting to another action, you use this result rather than the standard redirect result.

See examples below for an example of how request parameters could be passed in. This result type takes the following parameters:

Example:

<package name="public" extends="struts-default">
<action name="login" class="...">
<!-- Redirect to another namespace -->
<result type="redirect-action">
<param name="actionName">dashboard</param>
<param name="namespace">/secure</param>
</result>
</action>
</package>

<package name="secure" extends="struts-default" namespace="/secure">
<-- Redirect to an action in the same namespace -->
<action name="dashboard" class="...">
<result>dashboard.jsp</result>
<result name="error" type="redirect-action>error</result>
</action>

<action name="error" class="...">
<result>error.jsp</result>
</action>
</package>

<package name="passingRequestParameters" extends="struts-default" namespace="/passingRequestParameters">
<-- Pass parameters (reportType, width and height) -->
<!--
The redirect-action url generated will be :
/genReport/generateReport.action?reportType=pie&width=100&height=100
-->
<action name="gatherReportInfo" class="...">
<result name="showReportResult" type="redirect-action">
<param name="actionName">generateReport</param>
<param name="namespace">/genReport</param>
<param name="reportType">pie</param>
<param name="width">100</param>
<param name="height">100</param>
</result>
</action>
</package>


Field Summary
public static final  String DEFAULT_PARAM    The default parameter 
protected  String actionName     
protected  String namespace     
protected  String method     
protected  List prohibitedResultParam     
Fields inherited from org.apache.struts2.dispatcher.ServletRedirectResult:
prependServletContext,  actionMapper
Fields inherited from org.apache.struts2.dispatcher.StrutsResultSupport:
DEFAULT_PARAM
Constructor:
 public ServletActionRedirectResult() 
 public ServletActionRedirectResult(String actionName) 
 public ServletActionRedirectResult(String actionName,
    String method) 
 public ServletActionRedirectResult(String namespace,
    String actionName,
    String method) 
Method from org.apache.struts2.dispatcher.ServletActionRedirectResult Summary:
addParameter,   execute,   setActionName,   setMethod,   setNamespace
Methods from org.apache.struts2.dispatcher.ServletRedirectResult:
doExecute,   setActionMapper,   setPrependServletContext
Methods from org.apache.struts2.dispatcher.StrutsResultSupport:
conditionalParse,   doExecute,   execute,   getLastFinalLocation,   setEncode,   setLocation,   setParse
Methods from java.lang.Object:
equals,   getClass,   hashCode,   notify,   notifyAll,   toString,   wait,   wait,   wait
Method from org.apache.struts2.dispatcher.ServletActionRedirectResult Detail:
 public ServletActionRedirectResult addParameter(String key,
    Object value) 
    Adds a request parameter to be added to the redirect url
 public  void execute(ActionInvocation invocation) throws Exception 
 public  void setActionName(String actionName) 
    Sets the action name
 public  void setMethod(String method) 
    Sets the method
 public  void setNamespace(String namespace) 
    Sets the namespace